#!/bin/sh
# ----------------------------------------------------------------------------
#
# This variable should be set to the directory where is installed PROACTIVE
#

CLASSPATH=.

workingDir=`dirname $0`
PROACTIVE=$(cd $workingDir/.././ || (echo "Broken PROACTIVE installation" ; exit 1) && echo $PWD)

# ----------------------------------------------------------------------------


JAVA_HOME=${JAVA_HOME-NULL};
if [ "$JAVA_HOME" = "NULL" ]
then
echo
echo "The enviroment variable JAVA_HOME must be set the current jdk distribution"
echo "installed on your computer."
echo "Use "
echo "    export JAVA_HOME=<the directory where is the JDK>"
exit 127
fi

# ----
# Set up the classpath using classes dir or jar files
#

if [ -d $PROACTIVE/classes ]
then
    CLASSPATH=$CLASSPATH:$PROACTIVE/classes
    for i in $PROACTIVE/lib/*.jar ; do
      CLASSPATH=$CLASSPATH:$i
    done
    for i in $PROACTIVE/lib/ProActive/*.jar ; do
      CLASSPATH=$CLASSPATH:$i
    done
else
    CLASSPATH=$CLASSPATH:$PROACTIVE/dist/lib/ProActive.jar
    CLASSPATH=$CLASSPATH:$PROACTIVE/dist/lib/MCPricingContest.jar
fi

#echo "CLASSPATH"=$CLASSPATH
export CLASSPATH

echo $JAVA_HOME
JAVACMD=$JAVA_HOME/bin/java"\
	-Djava.security.manager \
	-Djava.security.policy=$PROACTIVE/bin/proactive.java.policy \
	-Dlog4j.configuration=file:${PROACTIVE}/bin/proactive-log4j \
	-Dproactive.home=$PROACTIVE \
	-Dos=unix"

export PROACTIVE
export JAVACMD
