/*
 * ################################################################
 *
 * ProActive: The Java(TM) library for Parallel, Distributed,
 *            Concurrent computing with Security and Mobility
 *
 * Copyright (C) 1997-2008 INRIA/University of Nice-Sophia Antipolis
 * Contact: proactive@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Initial developer(s):               The ProActive Team
 *                        http://proactive.inria.fr/team_members.htm
 *  Contributor(s):
 *
 * ################################################################
 * $$PROACTIVE_INITIAL_DEV$$
 */
package plugtest.data;

//---------------------------------/
//- Imported classes and packages -/
//---------------------------------/

import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;


/**
 * This class is a collection of results of the individual classes.
 * 
 *  
 * 
 * @version $Revision$ $Date$
 */
public class Results implements java.io.Serializable {

    //--------------------------/
    //- Class/Member Variables -/
    //--------------------------/

    /**
     * Holds the computed prices, greeks and relevent computational
     * parameters. 
     *  
     */
    private java.util.List _resultList;

    /**
     * The metrics stores the computational time required to to
     *  compute any element. 
     */
    private plugtest.data.Metrics _metrics;

    //----------------/
    //- Constructors -/
    //----------------/

    public Results() {
        super();
        this._resultList = new java.util.ArrayList();
    }

    //-----------/
    //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param vResult
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     */
    public void addResult(final plugtest.data.Result vResult) throws java.lang.IndexOutOfBoundsException {
        this._resultList.add(vResult);
    }

    /**
     * 
     * 
     * @param index
     * @param vResult
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     */
    public void addResult(final int index, final plugtest.data.Result vResult)
            throws java.lang.IndexOutOfBoundsException {
        this._resultList.add(index, vResult);
    }

    /**
     * Method enumerateResult.
     * 
     * @return an Enumeration over all possible elements of this
     * collection
     */
    public java.util.Enumeration enumerateResult() {
        return java.util.Collections.enumeration(this._resultList);
    }

    /**
     * Returns the value of field 'metrics'. The field 'metrics'
     * has the following description: The metrics stores the
     * computational time required to to
     *  compute any element. 
     * 
     * @return the value of field 'Metrics'.
     */
    public plugtest.data.Metrics getMetrics() {
        return this._metrics;
    }

    /**
     * Method getResult.
     * 
     * @param index
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     * @return the value of the plugtest.data.Result at the given
     * index
     */
    public plugtest.data.Result getResult(final int index) throws java.lang.IndexOutOfBoundsException {
        // check bounds for index
        if (index < 0 || index >= this._resultList.size()) {
            throw new IndexOutOfBoundsException("getResult: Index value '" + index + "' not in range [0.." +
                (this._resultList.size() - 1) + "]");
        }

        return (plugtest.data.Result) _resultList.get(index);
    }

    /**
     * Method getResult.Returns the contents of the collection in
     * an Array.  <p>Note:  Just in case the collection contents
     * are changing in another thread, we pass a 0-length Array of
     * the correct type into the API call.  This way we <i>know</i>
     * that the Array returned is of exactly the correct length.
     * 
     * @return this collection as an Array
     */
    public plugtest.data.Result[] getResult() {
        plugtest.data.Result[] array = new plugtest.data.Result[0];
        return (plugtest.data.Result[]) this._resultList.toArray(array);
    }

    /**
     * Method getResultCount.
     * 
     * @return the size of this collection
     */
    public int getResultCount() {
        return this._resultList.size();
    }

    /**
     * Method isValid.
     * 
     * @return true if this object is valid according to the schema
     */
    public boolean isValid() {
        try {
            validate();
        } catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    }

    /**
     * Method iterateResult.
     * 
     * @return an Iterator over all possible elements in this
     * collection
     */
    public java.util.Iterator iterateResult() {
        return this._resultList.iterator();
    }

    /**
     * 
     * 
     * @param out
     * @throws org.exolab.castor.xml.MarshalException if object is
     * null or if any SAXException is thrown during marshaling
     * @throws org.exolab.castor.xml.ValidationException if this
     * object is an invalid instance according to the schema
     */
    public void marshal(final java.io.Writer out) throws org.exolab.castor.xml.MarshalException,
            org.exolab.castor.xml.ValidationException {
        Marshaller.marshal(this, out);
    }

    /**
     * 
     * 
     * @param handler
     * @throws java.io.IOException if an IOException occurs during
     * marshaling
     * @throws org.exolab.castor.xml.ValidationException if this
     * object is an invalid instance according to the schema
     * @throws org.exolab.castor.xml.MarshalException if object is
     * null or if any SAXException is thrown during marshaling
     */
    public void marshal(final org.xml.sax.ContentHandler handler) throws java.io.IOException,
            org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException {
        Marshaller.marshal(this, handler);
    }

    /**
     */
    public void removeAllResult() {
        this._resultList.clear();
    }

    /**
     * Method removeResult.
     * 
     * @param vResult
     * @return true if the object was removed from the collection.
     */
    public boolean removeResult(final plugtest.data.Result vResult) {
        boolean removed = _resultList.remove(vResult);
        return removed;
    }

    /**
     * Method removeResultAt.
     * 
     * @param index
     * @return the element removed from the collection
     */
    public plugtest.data.Result removeResultAt(final int index) {
        java.lang.Object obj = this._resultList.remove(index);
        return (plugtest.data.Result) obj;
    }

    /**
     * Sets the value of field 'metrics'. The field 'metrics' has
     * the following description: The metrics stores the
     * computational time required to to
     *  compute any element. 
     * 
     * @param metrics the value of field 'metrics'.
     */
    public void setMetrics(final plugtest.data.Metrics metrics) {
        this._metrics = metrics;
    }

    /**
     * 
     * 
     * @param index
     * @param vResult
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     */
    public void setResult(final int index, final plugtest.data.Result vResult)
            throws java.lang.IndexOutOfBoundsException {
        // check bounds for index
        if (index < 0 || index >= this._resultList.size()) {
            throw new IndexOutOfBoundsException("setResult: Index value '" + index + "' not in range [0.." +
                (this._resultList.size() - 1) + "]");
        }

        this._resultList.set(index, vResult);
    }

    /**
     * 
     * 
     * @param vResultArray
     */
    public void setResult(final plugtest.data.Result[] vResultArray) {
        //-- copy array
        _resultList.clear();

        for (int i = 0; i < vResultArray.length; i++) {
            this._resultList.add(vResultArray[i]);
        }
    }

    /**
     * Method unmarshal.
     * 
     * @param reader
     * @throws org.exolab.castor.xml.MarshalException if object is
     * null or if any SAXException is thrown during marshaling
     * @throws org.exolab.castor.xml.ValidationException if this
     * object is an invalid instance according to the schema
     * @return the unmarshaled plugtest.data.Results
     */
    public static plugtest.data.Results unmarshal(final java.io.Reader reader)
            throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException {
        return (plugtest.data.Results) Unmarshaller.unmarshal(plugtest.data.Results.class, reader);
    }

    /**
     * 
     * 
     * @throws org.exolab.castor.xml.ValidationException if this
     * object is an invalid instance according to the schema
     */
    public void validate() throws org.exolab.castor.xml.ValidationException {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    }

}
