/*
 * ################################################################
 *
 * ProActive: The Java(TM) library for Parallel, Distributed,
 *            Concurrent computing with Security and Mobility
 *
 * Copyright (C) 1997-2008 INRIA/University of Nice-Sophia Antipolis
 * Contact: proactive@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Initial developer(s):               The ProActive Team
 *                        http://proactive.inria.fr/team_members.htm
 *  Contributor(s):
 *
 * ################################################################
 * $$PROACTIVE_INITIAL_DEV$$
 */
package plugtest.data.types;

//---------------------------------/
//- Imported classes and packages -/
//---------------------------------/

import java.util.Hashtable;


/**
 * Defines the payoff of the option. 
 *  
 * 
 * @version $Revision$ $Date$
 */
public class PayOffType implements java.io.Serializable {

    //--------------------------/
    //- Class/Member Variables -/
    //--------------------------/

    /**
     * The Min type
     */
    public static final int MIN_TYPE = 0;

    /**
     * The instance of the Min type
     */
    public static final PayOffType MIN = new PayOffType(MIN_TYPE, "Min");

    /**
     * The Max type
     */
    public static final int MAX_TYPE = 1;

    /**
     * The instance of the Max type
     */
    public static final PayOffType MAX = new PayOffType(MAX_TYPE, "Max");

    /**
     * The Avg type
     */
    public static final int AVG_TYPE = 2;

    /**
     * The instance of the Avg type
     */
    public static final PayOffType AVG = new PayOffType(AVG_TYPE, "Avg");

    /**
     * Field _memberTable.
     */
    private static java.util.Hashtable _memberTable = init();

    /**
     * Field type.
     */
    private int type = -1;

    /**
     * Field stringValue.
     */
    private java.lang.String stringValue = null;

    //----------------/
    //- Constructors -/
    //----------------/

    private PayOffType(final int type, final java.lang.String value) {
        super();
        this.type = type;
        this.stringValue = value;
    }

    //-----------/
    //- Methods -/
    //-----------/

    /**
     * Method enumerate.Returns an enumeration of all possible
     * instances of PayOffType
     * 
     * @return an Enumeration over all possible instances of
     * PayOffType
     */
    public static java.util.Enumeration enumerate() {
        return _memberTable.elements();
    }

    /**
     * Method getType.Returns the type of this PayOffType
     * 
     * @return the type of this PayOffType
     */
    public int getType() {
        return this.type;
    }

    /**
     * Method init.
     * 
     * @return the initialized Hashtable for the member table
     */
    private static java.util.Hashtable init() {
        Hashtable members = new Hashtable();
        members.put("Min", MIN);
        members.put("Max", MAX);
        members.put("Avg", AVG);
        return members;
    }

    /**
     * Method readResolve. will be called during deserialization to
     * replace the deserialized object with the correct constant
     * instance.
     * 
     * @return this deserialized object
     */
    private java.lang.Object readResolve() {
        return valueOf(this.stringValue);
    }

    /**
     * Method toString.Returns the String representation of this
     * PayOffType
     * 
     * @return the String representation of this PayOffType
     */
    public java.lang.String toString() {
        return this.stringValue;
    }

    /**
     * Method valueOf.Returns a new PayOffType based on the given
     * String value.
     * 
     * @param string
     * @return the PayOffType value of parameter 'string'
     */
    public static plugtest.data.types.PayOffType valueOf(final java.lang.String string) {
        java.lang.Object obj = null;
        if (string != null) {
            obj = _memberTable.get(string);
        }
        if (obj == null) {
            String err = "" + string + " is not a valid PayOffType";
            throw new IllegalArgumentException(err);
        }
        return (PayOffType) obj;
    }

}
